import { Api, replacer } from "../common/api.ts";
import { MakeHandlers, makeServe } from "../common/deps/yaypi.ts";

const handlers: MakeHandlers<typeof Api> = {
	v1: {
		listSchemas: async (limit) => [
			{
				id: 0,
				latestVersion: {
					version: 1,
					schema: {
						name: "Test",
						fields: [
							{
								name: "name",
								options: {
									displayAs: "input",
									minLength: 0,
								},
								kind: "string",
								required: true,
							},
						],
					},
				},
			},
		],
		saveSchema: async ({ schema, id }) => "todo",
	},
};

export const serveApi = makeServe(Api, handlers, "/api", replacer);
