export const setIdx = <T>(arr: T[], index: number, newValue: T): T[] => {
	const newArr = [...arr];
	newArr[index] = newValue;

	return newArr;
};

export const push = <T>(arr: T[], newValue: T) => [...arr, newValue];

export const deleteIdx = <T>(arr: T[], index: number): T[] => {
	const newArr = [...arr];
	newArr.splice(index, 1);

	return newArr;
};

export const setProp = <T, K extends keyof T>(
	obj: T,
	key: K,
	newValue: T[K],
): T => ({
	...obj,
	[key]: newValue,
});
