import { swel } from "../../deps/swel.ts";
import { CmpPaintComponent, Paint } from "../component.ts";

export class RecyclerList<T> extends CmpPaintComponent<T[]> {
	private views: CmpPaintComponent<T>[] = [];

	constructor(
		private makeChild: (index: number) => CmpPaintComponent<T>,
		private container = swel("div"),
	) {
		super();
	}

	get el(): HTMLElement {
		return this.container;
	}

	paint_: Paint<T[]> = (cur) => {
		const prev = this.previousModel;

		if (!prev) {
			this.views = cur.map((c, i) => {
				const view = this.makeChild(i);
				view.paint(c);
				this.container.appendChild(view.el);

				return view;
			});
		} else if (cur.length > prev.length) {
			let i = 0;
			for (; i < prev.length; ++i) {
				const c = cur[i];

				this.views[i].paint(c);
			}

			for (; i < cur.length; ++i) {
				const c = cur[i];

				this.views[i] ??= this.makeChild(i);
				const view = this.views[i];
				view.paint(c);
				this.container.appendChild(view.el);
			}
		} else if (cur.length <= prev.length) {
			let i = 0;
			for (; i < cur.length; ++i) {
				const c = cur[i];

				const view = this.views[i];
				view.paint(c);
			}

			for (; i < prev.length; ++i) {
				this.container.children[i].remove();
			}
		}
	};
}
