import { h } from "preact";
import { useRef } from "preact/hooks";
import { Callback } from "../../../utils.ts";

export const Checkbox = (p: {
	checked: boolean;
	onToggle: Callback<[boolean]>;
}) => {
	const ref = useRef<HTMLInputElement>(null);

	return h("input", {
		ref,
		type: "checkbox",
		checked: p.checked,
		onChange: () => p.onToggle(ref.current!.checked),
	});
};
