import { swel } from "../../../deps/swel.ts";
import { Callback } from "../../../utils.ts";
import { CmpPaintComponent, Paint } from "../../component.ts";

export class LabeledCheckbox extends CmpPaintComponent<boolean> {
	private label: HTMLLabelElement;
	private input: HTMLInputElement;

	constructor(label: string, p: { onToggle: Callback<[boolean]> }) {
		super();

		this.input = swel("input", {
			type: "checkbox",
			on: { change: () => p.onToggle(this.input.checked) },
		});

		this.label = swel("label", {}, [label, this.input]);
	}

	get el(): HTMLElement {
		return this.label;
	}

	protected paint_: Paint<boolean> = (cur) => {
		this.input.checked = cur;
	};
}
