import { JSX, h } from "preact";
import { useRef } from "preact/hooks";
import { Callback } from "../../../utils.ts";

export const NumberInput = (
	p: Omit<JSX.HTMLAttributes<HTMLInputElement>, "onInput"> & {
		value: number;
		min?: number;
		max?: number;
		onInput: Callback<[number]>;
	},
) => {
	const ref = useRef<HTMLInputElement>(null);

	return h("input", {
		...p,
		type: "number",
		ref,
		min: p.min,
		max: p.max,
		value: p.value,
		onInput: () => p.onInput(Number(ref.current!.value)),
	});
};
