import { h, JSX } from "preact";
import { useRef } from "preact/hooks";
import { Callback } from "../../../utils.ts";

export const TextInput = (
	p: Omit<JSX.HTMLAttributes<HTMLInputElement>, "onInput"> & {
		placeholder?: string;
		value: string;
		onInput: Callback<[string]>;
	},
) => {
	const ref = useRef<HTMLInputElement>(null);

	return h("input", {
		...p,
		ref,
		onInput: () => p.onInput(ref.current!.value),
	});
};
