import { ComponentChildren, h } from "preact";

export const Validated = (p: {
	errors?: string[];
	children?: ComponentChildren;
}) => {
	const errorText = h("div", { class: "error-message" }, ...(p.errors ?? []));

	return h(
		"div",
		{ class: `validated ${p.errors ? "error" : ""}` },
		p.children,
		errorText,
	);
};
