import { Opts, swel } from "../deps/swel.ts";

export const WithValidationError = (p: { c: HTMLElement }) => {
	const errorMsg = swel("div", { className: "error-message" }, "Space");
	const wrapper = swel("div", { className: "with-validation-error" }, [
		p.c,
		errorMsg,
	]);

	return {
		el: wrapper,
		updateError: (e?: string) => {
			if (e) {
				errorMsg.innerText = e;
				wrapper.classList.add("error");
			} else {
				wrapper.classList.remove("error");
			}
		},
	};
};

export const InputWithValidationError = (opts: Opts<"input">) => {
	const input = swel("input", opts);
	const withError = WithValidationError({ c: input });

	return {
		...withError,
		input,
	};
};

export const LabeledCheckbox = (p: {
	labelText: string;
	labelOpts?: Opts<"label">;
	inputOpts?: Omit<Opts<"input">, "type">;
}) => {
	const input = swel("input", { ...p.inputOpts, type: "checkbox" });
	const label = swel("label", p.labelOpts, [input, p.labelText]);

	return { label, input };
};
