import "preact/debug";
import { h, render } from "preact";

import { App } from "./components/App/App.ts";

import {
	LOCAL_STORAGE_KEY,
	defaultAppState,
	loadStateFromLocalStorage,
} from "./state/store.ts";

const init = () => {
	const state = loadStateFromLocalStorage();
	// const state = defaultAppState;
	const app = h(App, state);

	render(app, document.body);
};

document.addEventListener("DOMContentLoaded", init);
(window as any)["resetApp"] = () => {
	localStorage.removeItem(LOCAL_STORAGE_KEY);
	location.reload();
};
